unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, ShellApi;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ERMin: TEdit;
    Label4: TLabel;
    ERMax: TEdit;
    Label5: TLabel;
    EDMin: TEdit;
    Label6: TLabel;
    EDMax: TEdit;
    Label7: TLabel;
    EMinDist: TEdit;
    Label8: TLabel;
    EBSRD: TEdit;
    Label9: TLabel;
    RGBinaryClass: TRadioGroup;
    SESeed: TSpinEdit;
    SENP: TSpinEdit;
    EBoundaryRadius: TEdit;
    GBLJ: TGroupBox;
    EELJ: TEdit;
    Label10: TLabel;
    GBCustomPower: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    EDLJ: TEdit;
    GBLJ2: TGroupBox;
    ECPEnergy: TEdit;
    Label13: TLabel;
    EVis: TEdit;
    GoButton: TButton;
    CancelButton: TButton;
    EELJ2: TEdit;
    Label14: TLabel;
    EDLJ2: TEdit;
    Label15: TLabel;
    Log: TMemo;
    CBBoundary: TCheckBox;
    Label16: TLabel;
    EBoundaryEnergy: TEdit;
    SEBoundaryPower: TSpinEdit;
    Label17: TLabel;
    Label18: TLabel;
    ECPDistance: TEdit;
    GroupBox1: TGroupBox;
    Label19: TLabel;
    EBoundaryDistance: TEdit;
    EMaxStep: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    EDeltaT: TEdit;
    Label22: TLabel;
    SEMaxFps: TSpinEdit;
    procedure RGBinaryClassClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure GoButtonClick(Sender: TObject);
    procedure CBBoundaryClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.RGBinaryClassClick(Sender: TObject);
begin
  case RGBinaryClass.ItemIndex of
    0:
    begin
      GBCustomPower.Visible := True;
      GBLJ.Visible := False;
      GBLJ2.Visible := False;
    end;
    1:
    begin
      GBCustomPower.Visible := False;
      GBLJ.Visible := True;
      GBLJ2.Visible := False;
    end;
    2:
    begin
      GBCustomPower.Visible := False;
      GBLJ.Visible := False;
      GBLJ2.Visible := True;
    end;
  end;
end;

var count : integer = 1;

procedure TMainForm.GoButtonClick(Sender: TObject);
  var sc : TStringList; si : TStartupInfo; pi : TProcessInformation;
  var exitcode : DWORD;
  var curdir : array[0..260] of char;
  var newname : string;
begin
  sc := TStringList.Create;
  sc.Add('number_of_particles ' + IntToStr(SENP.Value));
  sc.Add('random_seed ' + IntToStr(SESeed.Value));
  sc.Add('particle_radius uniform ' + ERMin.Text + ' ' + ERMax.Text);
  sc.Add('particle_density uniform ' + EDMin.Text + ' ' + EDMax.Text);
  sc.Add('particle_minimal_distance ' + EMinDist.Text);
  sc.Add('particle_distribution_domain sphere [0,0,0] ' + EBSRD.Text);
  case RGBinaryClass.ItemIndex of
    0: sc.Add('binary_interaction custom_power ' + ECPEnergy.Text + ' ' + ECPDistance.Text + ' 2');
    1: sc.Add('binary_interaction lj ' + EELJ.Text + ' ' + EDLJ.Text);
    2: sc.Add('binary_interaction lj2 ' + EELJ2.Text + ' ' + EDLJ2.Text + ' -3');
  end;
  if CBBoundary.Checked then
  begin
    sc.Add('boundary_sphere [0,0,0] ' + EBoundaryRadius.Text + ' custom_power -' +
      EBoundaryEnergy.Text + ' ' + EBoundaryDistance.Text + ' ' + SEBoundaryPower.Text);
  end;
  sc.Add('environmental_interaction ' + EVis.Text + ' vec3_constant 0 0 0');
  sc.Add('solution_time_limit 1e+12');
  sc.Add('solution_realtime_limit 36000');
  sc.Add('solution_maximal_step ' + EMaxStep.Text);
  sc.Add('solution_RK_tolerance 1e-6');
  sc.Add('solution_RK_timeout 20');
  sc.Add('saves_per_second ' + SEMaxFps.Text);
  sc.Add('hack_delta_t ' + EDeltaT.Text);
  sc.Add('monitor_setup "view_width 800 view_height 600 antialias"');
  sc.SaveToFile('temp.psdl');
  sc.Free;

  si.cb := sizeof(si);
  si.lpReserved := nil;
  si.lpDesktop := nil;
  si.lpTitle := PChar('PSMOD console');
  si.dwX := 0;
  si.dwY := 0;
  si.dwXSize := 800;
  si.dwYSize := 600;
  si.dwXCountChars := 80;
  si.dwYCountChars := 25;
  si.dwFillAttribute := FOREGROUND_RED + FOREGROUND_GREEN + FOREGROUND_INTENSITY + BACKGROUND_BLUE;
  si.dwFlags := STARTF_USECOUNTCHARS + STARTF_USEFILLATTRIBUTE;
  si.wShowWindow := SW_SHOWNORMAL;
  si.cbReserved2 := 0;
  si.lpReserved2 := nil;
  si.hStdInput := 0;
  si.hStdOutput := 0;
  si.hStdError := 0;

  ZeroMemory(@pi,sizeof(pi));

  if not CreateProcess(nil,'.\psmod\psmod.exe ./temp.psdl',nil,nil,False,0,nil,nil,si,pi) then
  begin
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
    Windows.MessageBox(Handle,'  ',' ',MB_ICONHAND);
    exit;
  end;
  CloseHandle(pi.hThread);
  Visible := False;
  WaitForSingleObject(pi.hProcess,INFINITE);
  GetExitCodeProcess(pi.hProcess,exitcode);
  CloseHandle(pi.hProcess);
  Visible := True;
  Log.Lines.Clear;
  Log.Lines.LoadFromFile('out\psmod.log');
  if exitcode <> 0 then
  begin
    Windows.MessageBox(Handle,'    ' +
      '  ','   ',
      MB_ICONHAND);
  end
  else
  begin
    GetCurrentDirectory(260,curdir);
    newname := 'out\tmp' + IntToStr(count) + 'out.csv';
    Windows.CopyFile('out\av_and_dev.csv',PChar(newname),False);
    ShellExecute(Handle,nil,'excel.exe',PChar(newname),curdir,SW_SHOWDEFAULT);
    count := count + 1;
  end;
end;

procedure TMainForm.CBBoundaryClick(Sender: TObject);
begin
  EBoundaryRadius.Enabled := CBBoundary.Checked;
  EBoundaryEnergy.Enabled := CBBoundary.Checked;
  EBoundaryDistance.Enabled := CBBoundary.Checked;
  SEBoundaryPower.Enabled := CBBoundary.Checked;
end;

end.
